﻿using System;
using System.Windows;
using System.Windows.Media.Animation;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.storyboard.CurrentStateInvalidated      += storyboard_CurrentStateInvalidated;
            this.widthAnimation1.CurrentStateInvalidated += widthAnimation1_CurrentStateInvalidated;
            this.widthAnimation2.CurrentStateInvalidated += widthAnimation2_CurrentStateInvalidated;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 스토리보드 현재 상태 무효시 처리하기 - storyboard_CurrentStateInvalidated(sender, e)

        /// <summary>
        /// 스토리보드 현재 상태 무효시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void storyboard_CurrentStateInvalidated(object sender, EventArgs e)
        {
            Clock clock = sender as Clock;

            this.listBox1.Items.Add($"{clock.CurrentTime} : {clock.CurrentState}");
        }

        #endregion
        #region 너비 애니메이션 1 현재 상태 무효시 처리하기 - widthAnimation1_CurrentStateInvalidated(sender, e)

        /// <summary>
        /// 너비 애니메이션 1 현재 상태 무효시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void widthAnimation1_CurrentStateInvalidated(object sender, EventArgs e)
        {
            Clock clock = sender as Clock;

            this.listBox2.Items.Add($"{clock.CurrentTime} : {clock.CurrentState}");
        }

        #endregion
        #region 너비 애니메이션 2 현재 상태 무효시 처리하기 - widthAnimation2_CurrentStateInvalidated(sender, e)

        /// <summary>
        /// 너비 애니메이션 2 현재 상태 무효시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void widthAnimation2_CurrentStateInvalidated(object sender, EventArgs e)
        {
            Clock clock = sender as Clock;

            this.listBox3.Items.Add($"{clock.Parent.CurrentTime} : {clock.CurrentState}");
        }

        #endregion
    }
}